# -- CUT FROM THIS POINT UPWARDS --
# This dump was automatically generated by myopt
# User ssottoco (Simone Sottocornola,26 2-004,+41227678947,) at Wed May 22 14:31:42 2019

# All options should be inside the 'option' dictionary
# The keys being the long name of the options and the
# values, the new default to be attributed.
option = {}

# ================================
# ' ignore' options 
# ================================

# This is just a dirty trick to dump import statements. IGNORE IT
import collections
Crate = collections.namedtuple("Crate", "name computer stringmap")
option['PleaseIgnoreMe'] = False

# ================================
# 'Dataflow' options 
# ================================

# List of data files to preload or the size of the dummy ROBs
option['data'] = 100

# ================================
# 'Partition making' options 
# ================================

# If this flag is set, the output will not contain any applications, but just the control tree (useful for controller-only tests)
option['control-only'] = False

# If you set this option it has to point to python module that contains a function named "modify" that will take the object generated (segment or partition) and post process it using such a function. This function should just modify the required objects and attributes and return the outcome. PartitionMaker will persistify that result. The specification of the module path follows the python standard, separating paths with dots. Any valid python module in PYTHONPATH or sys.path will work. Multiples of this option may be given at the command line in which case the filters are applied sequentially.
option['post-processor'] = []

# Which standard template file to include in your partition. This file contains the RC and RDB templates to be used at your segment or partition.
option['template-file'] = 'daq/sw/common-templates.data.xml'

# Add a RepositoryRoot to the partition
option['repository-root'] = ''

# Which setup file to include in your partition
option['setup-file'] = 'daq/segments/setup.data.xml'

# Extra OKS includes to your output
option['extra-includes'] = []

# ================================
# 'common' options 
# ================================

# If true, uses the slot assignments and cabling for the enhanced slice in tower 40.
#option['create_enhanced_slice40'] = True
option['create_enhanced_slice40'] = False

# Timeout of the RCD actions (e.g. transitions)
option['ActionTimeout'] = 60

# If true, will set up partition for Lab 4 testing.
#option['is_lab4'] = True
option['is_lab4'] = False

# Value in seconds of the publish_full_stat interval time.
#option['FullStatisticsInterval'] = 9999
option['FullStatisticsInterval'] = 60

# Partition name. If empty the partition object is not generated
option['partitionName'] = 'ProcessingUnit'

# Option used to enable running without AMB
#option['exclude_amb'] = True
option['exclude_amb'] = False

# Host where the segment controller will be execute. If empty the current PC is used
option['segmentHost'] = ''

# Partition counters: list of 3 tuples representing events and rates for L1, HLT and SFO
option['partitionCounters'] = [('DF.HLTSV.Events.LVL1Events', 'DF.HLTSV.Events.Rate'), ('DF.HLTSV.Events.ProcessedEvents', 'DF.HLTSV.Events.Rate'), ('DF.SFO-1.EventsSaved', 'DF.SFO-1.CurrentEventSavedRate')]

# If true, uses the slot assignments and cabling for the full cabling and turns on DF shelf 4 and rack 05-09.
#option['create_multi_DF_PU_slice'] = True
option['create_multi_DF_PU_slice'] = False

# Suffix to be added to the generated files name (e.g. -SliceA, -Slice2)
option['file_suffix'] = '-PU'

# If true, uses the slot assignments and cabling for the full configuration with only tower 35 enabled.
#option['create_slice_35'] = True
option['create_slice_35'] = False

# If true, makes sure we use all constants and pbanks for data, not MC.
#option['use_data_alignment'] = False
option['use_data_alignment'] = True

# If true, overwrites options based on an m14 configuration.
#option['use_m14_opts'] = True
option['use_m14_opts'] = False

# If true, uses the slot assignments and cabling for the full cabling and turns on DF shelf 1 and rack 05-07.
#option['create_alberto_slice'] = True
option['create_alberto_slice'] = False

# If true, uses the slot assignments and cabling for the full configuration with all towers enabled.
#option['create_final_config'] = True
option['create_final_config'] = False

# If true, will generate t configuration partition (adding the FTK_LOAD_MODE variable).
#option['is_lab4'] = False
option['isLoadMode'] = True

# Option used to enable running without AUX
#option['exclude_aux'] = True
option['exclude_aux'] = False

# If set to false the segment is not generated: i.e. only the RCD files are created
option['generateSegment'] = True

# Flag to control whether or not a separate thread should be created for configuring each ReadOutModule.
#option['ThreadedConfigure_opt'] = 1
option['ThreadedConfigure_opt'] = 0

# If true, will use TVs without any hits.
#option['empty_tvs'] = True
option['empty_tvs'] = False

# List of ROS objects to be appended to the FTK segment. The objects are searched for in the file
# "ftk/segments/ROS/ROS-FTK-robin-dc.data.xml", that is considered as an input parameter.
# If the list is empty, no ROSs are linked to the FTK segment
# Eg: option['ROSs'] = ["ROS-TDQ-FTK-00", "ROS-TDQ-FTK-01"]
option['ROSs'] = []

# Whether to use multithreading options
option['UseMultithreading'] = 1

# If true, uses the slot assignments and cabling for the enhanced slice.
option['create_enhanced_slice'] = False
#option['create_enhanced_slice'] = True

# Value in seconds of the publish interval time.
#option['ProbeInterval'] = 60
option['ProbeInterval'] = 20

# Whether to generate the Manager Application for this partition
option['generate_manager'] = False

# If true, uses the slot assignments and cabling for the full configuration with only tower 35 enabled, but all shelf 1 DFs.
#option['create_slice_35_allDF'] = True
option['create_slice_35_allDF'] = False

# Specify the directory for log files
option['logRoot'] = '/logs'

# This is the tower the slice is running with.
#option['tower'] = 11
option['tower'] = 22

# Option used to enable running without SSB
#option['exclude_ssb'] = True
option['exclude_ssb'] = False

# ================================
# 'df' options 
# ================================

# IM Hit/Module removal for IBL (31:enable bit, 15:0 limit of fillgap event)
option['IM_HIT_PER_MODULE_IBL'] = '0x800000ff'

# If true, generates all configuration files
option['GenerateConfiguration'] = False

# IM General used register, ask Masahiro
option['IM_SPECIAL5'] = 0

# uhal IPBus SW emulator mode. (default) 0=no emulator. 1=spy on IPBus packets, forward to DF hardware. 2=no hardware, RC ignores IPBus responses.
option['IPBusEmulatorMode'] = 0

# IM enable just 1 bit for enabling Pseudo data initial delay fix
option['IM_PSEUDO_DATA_INITIAL_DELAY'] = '0x1'

# Python list describing each DF shelf. Each element in the list is a python
# a tuple composed of 3 strings: shelf number, pc name, shelf map. The latter
# is string where the index represents the slot and the characters means:
# "D"=DF board, "x"=board disabled, "_"=unused slot. [NB: slot 0 does not exist, 1 is switch, 2 is blocked] 
# Full rack configuration: ' _ _ D D D D _ _ D D D D _ _ ' 
# Physical to logical map: '     9 7 5 3 1 2 4 6 8 10    '
# For Lab4 just pass 1 DF (see below)
# E.g:
# option['df-shelves'] = [
# ("1","pc-ftk-tdq-01.cern.ch","__DDDD__DDDD__"),
# ("2","pc-ftk-tdq-01.cern.ch","__DDDD__DDDD__"),
# ("3","pc-ftk-tdq-01.cern.ch","__DxxD__DDxx__"),
# ("4","pc-ftk-tdq-01.cern.ch","__xxxx__DDDD__") ]
#
# option['df-shelves'] = [ #pc-ftk-tdq-01.cern.ch P1, pc-tbed-ftk-01.cern.ch Lab4 
# ("1","pc-tbed-ftk-01.cern.ch","__xxxx__Dxxx__")] # If lab 4, pass this
option['df-shelves'] = []

# Just an example
option['DFFoobar'] = 'FooBar'

# Maximum timeout threshold to drop IM input lane. Default 0x30000 = ~1 ms
option['DF_skewTimeoutThresholdMax'] = '0x30000'

# DF_doFWCheck
option['DF_doFWCheck'] = 1

# Base folder containing DF configuration
option['DFConfigFolder'] = '/afs/cern.ch/work/s/ssottoco/public/Partitions/PU/ftk/DFconfigFiles/'

# IM Pseudo data input rate value in kHz (default is 100 kHz)
option['IM_PSEUDO_INPUT_RATE'] = '0x64'

# IM FW version which should be loaded
option['IM_FwVersion'] = '0x0'

# IM Hit/Module removal for PIX (31:enable bit, 15:0 limit of fillgap event)
option['IM_HIT_PER_MODULE_PIX'] = '0x800000ff'

# Location of address_df.xml
#option['address_df_location']='/tbed/ftk/condDB/latest/DataFormatter/ver1.5/config/address_df.xml' #l4
option['address_df_location'] = '/det/ftk/repo/condDB/latest/DataFormatter/ver1.6/config/address_df.xml'

# IM L1ID Freeze Mask
option['IM_L1ID_FREEZE_MASK'] = 0

# Use DF22, the DF in lab4. If generating a partition for p1, False; if for lab4, true.
option['use_df22'] = False

# IM Error Freeze Mask 2
option['IM_ERR_FREEZE_MASK2'] = 0

# Extra includes for the DF RCDs.
option['df-extra-inc'] = []

# IM Error Freeze Mask 1
option['IM_ERR_FREEZE_MASK1'] = 0

# Use pseudodata for this run. Default OKS value is False.
option['usePseudoData'] = False

# DF_MaxCyclesWaitedForData
option['DF_MaxCyclesWaitedForData'] = '0x4fff'

# IM Sync Start L1ID Value
option['IM_START_L1ID_VALUE'] = 0

# IM L1ID Prescale Value
option['IM_L1ID_PS_VALUE'] = '0x0'

# Indicate name of directory containing LUTs
#option['LUTs_directory']='/tbed/ftk/condDB/latest/DataFormatter/ver1.5/config/IM_LUTs_Data2017/' #Lab4
option['LUTs_directory'] = '/det/tdaq/ftk/repo/condDB/latest/DataFormatter/ver1.6/config/IM_LUTs_Data2017'

# Channel mask for enabling SLINK, SLINK is disabled by default
option['IM_SLINK_MODE_MASK'] = '0x0'

# IM Enable bit (just 1bit) for enabling Select PreScale for L1ID
option['IM_IS_APPLY_SELECTPS'] = '0x0'

# Indicate name of directory containing pseudodata to use
#option['PseudoData_directory']='/det/ftk/repo/condDB/latest/DataFormatter/ver1.6/config/pseudo_data_20170624'
option['PseudoData_directory'] = ''

# Trigger type prescale mask. Default 32 = 0x20 = FTK trigger type
option['IM_L1TT_PS_MASK'] = '0x20'

# IM Sync Start L1ID Mask (was 28bit sync)
option['IM_START_L1ID_MASK'] = 0

# IM L1ID Freeze Value
option['IM_L1ID_FREEZE_VALUE'] = 0

# DF_FwVersion (default fw release 02)
option['DF_FwVersion'] = '0x1803e'

# IM Hit/Module removal for SCT (31:enable bit, 15:0 limit of fillgap event)
option['IM_HIT_PER_MODULE_SCT'] = '0x800000ff'

# DF_use_auto_delay_setting
option['DF_use_auto_delay_setting'] = 1

# IM Enable bit (just 1bit) for enabling duplicated module removal
option['IM_DUPLICATED_MODULE'] = '0x0'

# A mask to toggle whether RC should fail on a link having bad status. If 0 for a given link, then just print a warning. Default = 0x0 (never fail)
option['failOnBadLink'] = '0x0'

# Timeout threshold for the packet handler to complete a partial received packet. Default 0x4e20 = 100 us
option['DF_packetHandlerTimeoutThreshold'] = '0x4e20'

# IM L1ID Prescale Mask
option['IM_L1ID_PS_MASK'] = 0

# Give full path of Module List. Use defaults if not an expert!!!
#option['IM_ModuleListFile']='/tbed/ftk/condDB/latest/DataFormatter/ver1.5/config/modulelist_Data2017_64T.txt' #Lab4
option['IM_ModuleListFile'] = '/det/tdaq/ftk/repo/condDB/latest/DataFormatter/ver1.6/config/modulelist_Data2017_64T.txt'

# Minimum timeout threshold to drop IM input lane. Default 0xff = ~1 us
option['DF_skewTimeoutThresholdMin'] = '0xff'

# ================================
# 'flic' options 
# ================================

# 
option['TracksPerRecord'] = 13

# 
option['DelayBetweenSyncAttempts'] = 5

# 
option['ReloadSRAMs'] = 0

# 
option['LinksInUse'] = 1

# 
option['ReloadFirmware'] = 1

# Python list with IP information for each readout module (or board) in the shelf.
# Each tuple has 3 strings: flic IP, port, and host IP. The number of tuples
# must match the number of boards in the shelf (i.e. the number of F's written
# in each shelf). E.g.:
#  [ ("10.153.37.18","50000","10.153.37.16") ] for Lab4
#      -- or --
#  [ ("10.153.37.25","50000","10.153.37.17") ]
# option['flic-ips'] = [
# ( "10.153.37.25" , "50000" , "10.153.37.17" ) ]
option['flic-ips'] = [('10.153.37.25', '50000', '10.153.37.17')]

# 
option['TotalROSLinkResets'] = 1

# 
option['MonitoringChannel'] = 0

# 
option['TotalRecords'] = 0

# 
option['LoopbackMode'] = 0

# 
option['Verbose'] = 2

# 
option['DelayBetweenRecords'] = 1000

# 
option['UseAsSSBe'] = 0

# 
option['TotalSyncAttempts'] = 10

# Python list describing each FLIC shelf. Each element in the list is a python
# a tuple composed of 3 strings: shelf name, pc number, shelf map. The latter
# is string where the index represents the slot and the characters means:
# "F"=FLIC board and "_"=unused slot. [NB: slot 0 does not exist]. E.g.:
#  [ ("1","pc-tbed-ftk-01.cern.ch","___F_") ] for Lab4
#      -- or --
#  [ ("1","pc-ftk-tdq-04.cern.ch","_FF__") ] for P1
#
# option['flic-shelves'] = [( "1" , "pc-ftk-tdq-04.cern.ch" , "_F___" ) ]
option['flic-shelves'] = []

# Extra includes for the Flic RCDs.
option['flic-extra-inc'] = []

# 
option['CaptureCondition'] = 12

# 
option['IgnoreROSLinks'] = 0

# ================================
# 'vme' options 
# ================================

# Limit number of tracks considered from AUX
option['SSB_AUXLimit'] = '0xd8'

# Limit number of tracks from EXP
option['SSB_EXPLimit'] = '0x50'

# HW date,hash
option['SSB_HW_Hash'] = ['0x0', '0x0']

# FPGA Reset threshold
option['SSB_Reset_Threshold'] = '0x19999'

# EXTF date,hash
option['SSB_EXTF_Hash'] = ['0x0', '0x0']

# Base path for SSB SSMaps
option['SSB_SSMap_Base'] = '/det/ftk/repo/condDB/latest/SSB/64Tower_config/'

# Ignore DFB channel
option['SSB_IgnoreDFB'] = '1'

# Extra includes for the VME RCDs.
option['vme-extra-inc'] = []

# Freeze Mask
option['SSB_FreezeMask'] = '0x0'

# TF checksums
option['SSB_TF_Checksums'] = [[0, '0x0'], [1, '0x0'], [2, '0x0'], [3, '0x0'], [4, '0x0'], [5, '0x0'], [6, '0x0'], [7, '0x0'], [8, '0x0'], [9, '0x0'], [10, '0x0'], [11, '0x0'], [12, '0x0'], [13, '0x0'], [14, '0x0'], [15, '0x0'], [16, '0x0'], [17, '0x0'], [18, '0x0'], [19, '0x0'], [20, '0x0'], [21, '0x0'], [22, '0x0'], [23, '0x0'], [24, '0x0'], [25, '0x0'], [26, '0x0'], [27, '0x0'], [28, '0x0'], [29, '0x0'], [30, '0x0'], [31, '0x0'], [32, '0x0'], [33, '0x0'], [34, '0x0'], [35, '0x0'], [36, '0x0'], [37, '0x0'], [38, '0x0'], [39, '0x0'], [40, '0x0'], [41, '0x0'], [42, '0x0'], [43, '0x0'], [44, '0x0'], [45, '0x0'], [46, '0x0'], [47, '0x0'], [48, '0x0'], [49, '0x0'], [50, '0x0'], [51, '0x0'], [52, '0x0'], [53, '0x0'], [54, '0x0'], [55, '0x0'], [56, '0x0'], [57, '0x0'], [58, '0x0'], [59, '0x0'], [60, '0x0'], [61, '0x0'], [62, '0x0'], [63, '0x0'], [64, '0x0']]

# Chi2 cut on tracks out of TF, 0x5640=100
option['SSB_Chi2'] = '0x5640'

# EXP checksums
option['SSB_EXP_Checksums'] = [[0, '0x0'], [1, '0x0'], [2, '0x0'], [3, '0x0'], [4, '0x0'], [5, '0x0'], [6, '0x0'], [7, '0x0'], [8, '0x0'], [9, '0x0'], [10, '0x0'], [11, '0x0'], [12, '0x0'], [13, '0x0'], [14, '0x0'], [15, '0x0'], [16, '0x0'], [17, '0x0'], [18, '0x0'], [19, '0x0'], [20, '0x0'], [21, '0x0'], [22, '0x0'], [23, '0x0'], [24, '0x0'], [25, '0x0'], [26, '0x0'], [27, '0x0'], [28, '0x0'], [29, '0x0'], [30, '0x0'], [31, '0x0'], [32, '0x0'], [33, '0x0'], [34, '0x0'], [35, '0x0'], [36, '0x0'], [37, '0x0'], [38, '0x0'], [39, '0x0'], [40, '0x0'], [41, '0x0'], [42, '0x0'], [43, '0x0'], [44, '0x0'], [45, '0x0'], [46, '0x0'], [47, '0x0'], [48, '0x0'], [49, '0x0'], [50, '0x0'], [51, '0x0'], [52, '0x0'], [53, '0x0'], [54, '0x0'], [55, '0x0'], [56, '0x0'], [57, '0x0'], [58, '0x0'], [59, '0x0'], [60, '0x0'], [61, '0x0'], [62, '0x0'], [63, '0x0'], [64, '0x0']]

# Compute checksums of SSB EXP and TF constants.  This does not do anything
option['compute_SSB_checksums'] = False

# Option used to ignore BP from FLIC to SSB
#option['ignore_flic'] = True
option['ignore_flic'] = False

# Base path for SSB constants
option['SSB_Constants_Base'] = '/det/ftk/repo/condDB/latest/SSB/64Tower_config/'

# AUX Firmware versions
option['AUX_firmwareversions'] = {'Input2': 0, 'Processor4': 0, 'Input1': 0, 'Processor2': 0, 'Processor3': 0, 'Processor1': 0, 'fwtag': ''}

# Ignore AUXB channel
option['SSB_IgnoreAUXB'] = '1'

# Just an example
option['AmbFoobar'] = 'FooBar'

# Python list describing each vme crate. Each element in the list is a python
# tuple composed of 3 strings: crate number, sbc name, crate map. The latter is a 
# string where the index represents the slot and the characters means: "P"=PU, "S"==ssb
# "R"=RMDummy, "_"=unused slot. [NB: slot 0 does not exist and 1 is the SBC]. E.g.:
#option['vme-crates'] = [
#   ("4","sbc-tbed-ftk-04.cern.ch","__PPPPSPPPPSPPPSPPPS"),
#   ("2","sbc-tbed-ftk-02.cern.ch","__PPPPS_____PPPSPPPS") ]
option['vme-crates'] = [ ("7", "sbc-ftk-rcc-07.cern.ch","__P_________________") ]
#option['vme-crates'] = [ ("1","pc-tbed-pub-03.cern.ch","____RR______________")]
#option['vme-crates'] = []

